<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;cpp_demangle-0.3.5&#x2F;src&#x2F;subs.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>subs.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../cpp_demangle/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
</pre><pre class="rust"><code><span class="doccomment">//! Types dealing with the substitutions table.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::DemangleWrite</span>;
<span class="kw">use</span> <span class="ident">ast</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::iter::FromIterator</span>;
<span class="kw">use</span> <span class="ident">std::ops::Deref</span>;
<span class="kw">use</span> <span class="ident">vec::Vec</span>;

<span class="doccomment">/// An enumeration of all of the types that can end up in the substitution</span>
<span class="doccomment">/// table.</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::large_enum_variant</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Substitutable</span> {
    <span class="doccomment">/// An `&lt;unscoped-template-name&gt;` production.</span>
    <span class="ident">UnscopedTemplateName</span>(<span class="ident">ast::UnscopedTemplateName</span>),

    <span class="doccomment">/// A `&lt;type&gt;` production.</span>
    <span class="ident">Type</span>(<span class="ident">ast::Type</span>),

    <span class="doccomment">/// A `&lt;template-template-param&gt;` production.</span>
    <span class="ident">TemplateTemplateParam</span>(<span class="ident">ast::TemplateTemplateParam</span>),

    <span class="doccomment">/// An `&lt;unresolved-type&gt;` production.</span>
    <span class="ident">UnresolvedType</span>(<span class="ident">ast::UnresolvedType</span>),

    <span class="doccomment">/// A `&lt;prefix&gt;` production.</span>
    <span class="ident">Prefix</span>(<span class="ident">ast::Prefix</span>),
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;subs</span>, <span class="ident">W</span><span class="op">&gt;</span> <span class="ident">ast::Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;subs</span>, <span class="ident">W</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Substitutable</span>
<span class="kw">where</span>
    <span class="ident">W</span>: <span class="lifetime">&#39;subs</span> <span class="op">+</span> <span class="ident">DemangleWrite</span>,
{
    <span class="kw">fn</span> <span class="ident">demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;prev</span>, <span class="lifetime">&#39;ctx</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="lifetime">&#39;subs</span> <span class="self">self</span>,
        <span class="ident">ctx</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;ctx</span> <span class="kw-2">mut</span> <span class="ident">ast::DemangleContext</span><span class="op">&lt;</span><span class="lifetime">&#39;subs</span>, <span class="ident">W</span><span class="op">&gt;</span>,
        <span class="ident">scope</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">ast::ArgScopeStack</span><span class="op">&lt;</span><span class="lifetime">&#39;prev</span>, <span class="lifetime">&#39;subs</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Substitutable::UnscopedTemplateName</span>(<span class="kw-2">ref</span> <span class="ident">name</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">name</span>.<span class="ident">demangle</span>(<span class="ident">ctx</span>, <span class="ident">scope</span>),
            <span class="ident">Substitutable::Type</span>(<span class="kw-2">ref</span> <span class="ident">ty</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">ty</span>.<span class="ident">demangle</span>(<span class="ident">ctx</span>, <span class="ident">scope</span>),
            <span class="ident">Substitutable::TemplateTemplateParam</span>(<span class="kw-2">ref</span> <span class="ident">ttp</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">ttp</span>.<span class="ident">demangle</span>(<span class="ident">ctx</span>, <span class="ident">scope</span>),
            <span class="ident">Substitutable::UnresolvedType</span>(<span class="kw-2">ref</span> <span class="ident">ty</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">ty</span>.<span class="ident">demangle</span>(<span class="ident">ctx</span>, <span class="ident">scope</span>),
            <span class="ident">Substitutable::Prefix</span>(<span class="kw-2">ref</span> <span class="ident">prefix</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">prefix</span>.<span class="ident">demangle</span>(<span class="ident">ctx</span>, <span class="ident">scope</span>),
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">ast::GetLeafName</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Substitutable</span> {
    <span class="kw">fn</span> <span class="ident">get_leaf_name</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="self">self</span>, <span class="ident">subs</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">SubstitutionTable</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">ast::LeafName</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Substitutable::UnscopedTemplateName</span>(<span class="kw-2">ref</span> <span class="ident">name</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">name</span>.<span class="ident">get_leaf_name</span>(<span class="ident">subs</span>),
            <span class="ident">Substitutable::Prefix</span>(<span class="kw-2">ref</span> <span class="ident">prefix</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">prefix</span>.<span class="ident">get_leaf_name</span>(<span class="ident">subs</span>),
            <span class="ident">Substitutable::Type</span>(<span class="kw-2">ref</span> <span class="ident">ty</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">ty</span>.<span class="ident">get_leaf_name</span>(<span class="ident">subs</span>),
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }
}

<span class="kw">impl</span> <span class="ident">ast::IsCtorDtorConversion</span> <span class="kw">for</span> <span class="ident">Substitutable</span> {
    <span class="kw">fn</span> <span class="ident">is_ctor_dtor_conversion</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">subs</span>: <span class="kw-2">&amp;</span><span class="ident">SubstitutionTable</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Substitutable::Prefix</span>(<span class="kw-2">ref</span> <span class="ident">prefix</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">prefix</span>.<span class="ident">is_ctor_dtor_conversion</span>(<span class="ident">subs</span>),
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="bool-val">false</span>,
        }
    }
}

<span class="doccomment">/// The table of substitutable components that we have parsed thus far, and for</span>
<span class="doccomment">/// which there are potential back-references.</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Default</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SubstitutionTable</span> {
    <span class="ident">substitutions</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Substitutable</span><span class="op">&gt;</span>,
    <span class="comment">// There are components which are typically candidates for substitution, but</span>
    <span class="comment">// in some particular circumstances are not. Instances of such components</span>
    <span class="comment">// which are not candidates for substitution end up in this part of the</span>
    <span class="comment">// table. See `&lt;prefix&gt;` parsing for further details.</span>
    <span class="ident">non_substitutions</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Substitutable</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">SubstitutionTable</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">pad</span>(<span class="string">&quot;SubstitutionTable &quot;</span>)<span class="question-mark">?</span>;
        <span class="ident">f</span>.<span class="ident">debug_map</span>()
            .<span class="ident">entries</span>(<span class="self">self</span>.<span class="ident">substitutions</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>())
            .<span class="ident">finish</span>()<span class="question-mark">?</span>;
        <span class="ident">f</span>.<span class="ident">pad</span>(<span class="string">&quot;non_substitutions &quot;</span>)<span class="question-mark">?</span>;
        <span class="ident">f</span>.<span class="ident">debug_map</span>()
            .<span class="ident">entries</span>(<span class="self">self</span>.<span class="ident">non_substitutions</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>())
            .<span class="ident">finish</span>()
    }
}

<span class="kw">impl</span> <span class="ident">SubstitutionTable</span> {
    <span class="doccomment">/// Construct a new `SubstitutionTable`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">SubstitutionTable</span> {
        <span class="ident">Default::default</span>()
    }

    <span class="doccomment">/// Insert a freshly-parsed substitutable component into the table and</span>
    <span class="doccomment">/// return the index at which it now lives.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">insert</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">entity</span>: <span class="ident">Substitutable</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="ident">idx</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">substitutions</span>.<span class="ident">len</span>();
        <span class="macro">log!</span>(<span class="string">&quot;SubstitutionTable::insert @ {}: {:?}&quot;</span>, <span class="ident">idx</span>, <span class="ident">entity</span>);
        <span class="self">self</span>.<span class="ident">substitutions</span>.<span class="ident">push</span>(<span class="ident">entity</span>);
        <span class="ident">idx</span>
    }

    <span class="doccomment">/// Insert a an entity into the table that is not a candidate for</span>
    <span class="doccomment">/// substitution.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">insert_non_substitution</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">entity</span>: <span class="ident">Substitutable</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="ident">idx</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">non_substitutions</span>.<span class="ident">len</span>();
        <span class="self">self</span>.<span class="ident">non_substitutions</span>.<span class="ident">push</span>(<span class="ident">entity</span>);
        <span class="ident">idx</span>
    }

    <span class="doccomment">/// Does this substitution table contain a component at the given index?</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">idx</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="ident">idx</span> <span class="op">&lt;</span> <span class="self">self</span>.<span class="ident">substitutions</span>.<span class="ident">len</span>()
    }

    <span class="doccomment">/// Get the type referenced by the given handle, or None if there is no such</span>
    <span class="doccomment">/// entry, or there is an entry that is not a type.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_type</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">handle</span>: <span class="kw-2">&amp;</span><span class="ident">ast::TypeHandle</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">ast::Type</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">ast::TypeHandle::BackReference</span>(<span class="ident">idx</span>) <span class="op">=</span> <span class="kw-2">*</span><span class="ident">handle</span> {
            <span class="self">self</span>.<span class="ident">substitutions</span>.<span class="ident">get</span>(<span class="ident">idx</span>).<span class="ident">and_then</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="kw">match</span> <span class="kw-2">*</span><span class="ident">s</span> {
                <span class="ident">Substitutable::Type</span>(<span class="kw-2">ref</span> <span class="ident">ty</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="ident">ty</span>),
                <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
            })
        } <span class="kw">else</span> {
            <span class="prelude-val">None</span>
        }
    }

    <span class="doccomment">/// Remove the last entry from the substitutions table and return it, or</span>
    <span class="doccomment">/// `None` if the table is empty.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">pop</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Substitutable</span><span class="op">&gt;</span> {
        <span class="macro">log!</span>(<span class="string">&quot;SubstitutionTable::pop @ {}: {:?}&quot;</span>, <span class="self">self</span>.<span class="ident">len</span>(), <span class="self">self</span>.<span class="ident">last</span>());
        <span class="self">self</span>.<span class="ident">substitutions</span>.<span class="ident">pop</span>()
    }

    <span class="doccomment">/// Get the `idx`th entity that is not a candidate for substitution. Panics</span>
    <span class="doccomment">/// if `idx` is out of bounds.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">non_substitution</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">idx</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">Substitutable</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">non_substitutions</span>[<span class="ident">idx</span>]
    }

    <span class="doccomment">/// Get the `idx`th entity that is not a candidate for substitution. Returns</span>
    <span class="doccomment">/// `None` if `idx` is out of bounds.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_non_substitution</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">idx</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">Substitutable</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">non_substitutions</span>.<span class="ident">get</span>(<span class="ident">idx</span>)
    }
}

<span class="kw">impl</span> <span class="ident">FromIterator</span><span class="op">&lt;</span><span class="ident">Substitutable</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">SubstitutionTable</span> {
    <span class="kw">fn</span> <span class="ident">from_iter</span><span class="op">&lt;</span><span class="ident">I</span>: <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Substitutable</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">iter</span>: <span class="ident">I</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">SubstitutionTable</span> {
            <span class="ident">substitutions</span>: <span class="ident">Vec::from_iter</span>(<span class="ident">iter</span>),
            <span class="ident">non_substitutions</span>: <span class="macro">vec!</span>[],
        }
    }
}

<span class="kw">impl</span> <span class="ident">Deref</span> <span class="kw">for</span> <span class="ident">SubstitutionTable</span> {
    <span class="kw">type</span> <span class="ident">Target</span> <span class="op">=</span> [<span class="ident">Substitutable</span>];

    <span class="kw">fn</span> <span class="ident">deref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Target</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">substitutions</span>[..]
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="cpp_demangle" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>